program prog
   use modhash
   implicit none
   integer, parameter :: n=1000000
   character(len=11)  :: k(n), v(n), w(n)
   type (hashtable) :: h
   integer :: i
   real*8 :: t0,t1,dt,wallclock
   logical :: success

   do i=1,n
      write(k(i),'("k",i10.10)') i
      if (i < 5 .or. i > n-5) print *,i,k(i)
      write(v(i),'("v",i10.10)') i
   enddo

   call h%init

   t0 = wallclock()

   do i=1,n
      success = h%insert(k(i),v(i))
   enddo

   t1 = wallclock()
   dt = t1 - t0

   print *,'Fortran'
   print *,'Number of elements:',n
   print *,'Creating hashtable: ',dt,'seconds' 

   t0 = wallclock()
   do i=1,n
      w(i) = h%lookup(k(i))
   enddo
   t1 = wallclock()
   dt = t1 - t0
   print *,'Finding all elements: ',dt,'seconds' 

   t0 = wallclock()
   do i=1,n
      success = h%insert(k(i),v(i))
   enddo
   t1 = wallclock()
   dt = t1 - t0
   print *,'Rewriting all elements: ',dt,'seconds' 
   print *,'End Fortran'


end program prog
